#include "../definiciones.h"
#include "../Funciones_TPI.h"
#include "../ejercicios.h"
#include "gtest/gtest.h"
#include <iostream>
#include <string>

using namespace std;


TEST(muestraHomogeneaTEST, sinSolucion) {
    vector <hogar> res = {};
    eph_h th = {
            {960,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {210,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {200,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {334,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {543,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {2354,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {1,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {800,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
    };

    eph_i ti = {{543,  1, 2017, 1, 0, 1, 36, 1,  3, 1, 1}, // 1
                {334,  1, 2017, 1, 0, 1, 36, 1,  3, 1, 1}, // 3
                {334,  2, 2017, 1, 0, 1, 36, 1,  3, 2, 1},
                {340,  1, 2017, 1, 0, 1, 36, 1,  3, 300, 1},  // 300
                {340,  3, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
                {1009,  1, 2017, 1, 0, 1, 36, 1,  3, 26, 1}, // 26
                {210,  1, 2017, 1, 0, 1, 36, 1,  3, 25, 1}, // 27
                {210,  2, 2017, 1, 0, 1, 36, 1,  3, 2, 1},
                {1,  1, 2017, 1, 0, 1, 36, 1,  3, 24, 1}, // 24
                {4377,  1, 2017, 1, 0, 1, 36, 1,  3, 35, 1}, // 50
                {4377,  3, 2017, 1, 0, 1, 36, 1,  3, 15, 1},
                {2354,  1, 2017, 1, 0, 1, 36, 1,  3, 20, 1}, // 20
                {800,  2, 2017, 1, 0, 1, 36, 1,  3, 0, 1}, // 0
                {200,  2, 2017, 1, 0, 1, 36, 1,  3, 0, 1}, // 0
                {960,  3, 2017, 1, 1, 2, 51, 1,  4, 0,  1}, // 0
                {960,  2, 2017, 1, 1, 2, 51, 1,  4, 0,  1},
                {960,  1, 2017, 1, 1, 2, 51, 1,  4, 0,  1}};
    EXPECT_EQ(res,muestraHomogenea(th,ti));
}


TEST(muestraHomogeneaTEST, variasDe3UnaLarga) {
    vector <hogar> res = {{543,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
                          {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
                          {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
                          {1,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
                          {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
                          {800,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
                          {200,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
                          {760,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
                          {660,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
                          {460,  2017, 1, 1, 1, 0, 1, 4, 1, 2}
    };
    eph_h th = {
            {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {210,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {200,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {334,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {543,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {2354,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {1,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {800,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {960,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {760,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {660,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {560,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {460,  2017, 1, 1, 1, 0, 1, 4, 1, 2}
    };


    eph_i ti = {{543,  1, 2017, 1, 0, 1, 36, 1,  3, 1, 1}, // 1
                {334,  2, 2017, 1, 0, 1, 36, 1,  3, 2, 1}, // 2
                {340,  1, 2017, 1, 0, 1, 36, 1,  3, 3, 1}, // 3
                {340,  3, 2017, 1, 0, 1, 36, 1,  3, -1, 1},
                {1009,  1, 2017, 1, 0, 1, 36, 1,  3, 5, 1}, // 5
                {210,  1, 2017, 1, 0, 1, 36, 1,  3, 6, 1}, // 6
                {210,  2, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
                {1,  1, 2017, 1, 0, 1, 36, 1,  3, 7, 1}, // 7
                {4377,  1, 2017, 1, 0, 1, 36, 1,  3, 9, 1}, // 9
                {4377,  3, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
                {2354,  1, 2017, 1, 0, 1, 36, 1,  3, 10, 1}, // 10
                {800,  2, 2017, 1, 0, 1, 36, 1,  3, 11, 1}, // 11
                {200,  2, 2017, 1, 0, 1, 36, 1,  3, 13, 1},
                {960,  3, 2017, 1, 1, 2, 51, 1,  4, 14,  1},
                {960,  2, 2017, 1, 1, 2, 51, 1,  4, 0,  1},
                {960,  1, 2017, 1, 1, 2, 51, 1,  4, 0,  1},
                {760,  1, 2017, 1, 1, 2, 51, 1,  4, 15,  1},
                {660,  1, 2017, 1, 1, 2, 51, 1,  4, 17,  1},
                {560,  1, 2017, 1, 1, 2, 51, 1,  4, 18,  1},
                {460,  1, 2017, 1, 1, 2, 51, 1,  4, 19,  1}};
    EXPECT_EQ(res,muestraHomogenea(th,ti));
}


TEST(muestraHomogeneaTEST, dosSolucionesDe3) {
    vector <hogar> res1 = {{ 1, 2017, 1, 1, 2, 0, 1, 3, 1, 2 },
                           { 210, 2017, 1, 1, 2, 0, 1, 3, 1, 2 },
                           { 340, 2017, 1, 1, 1, 0, 1, 4, 1, 2 }};

    vector <hogar> res2 = {{ 1, 2017, 1, 1, 2, 0, 1, 3, 1, 2 },
                           { 210, 2017, 1, 1, 2, 0, 1, 3, 1, 2 },
                           {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2}};

    eph_h th = {
            {960,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {210,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {200,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {334,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {543,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {2354,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {1,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {800,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
    };

    eph_i ti = {{543,  1, 2017, 1, 0, 1, 36, 1,  3, 1, 1}, // 1
                {334,  1, 2017, 1, 0, 1, 36, 1,  3, 1, 1}, // 3
                {334,  2, 2017, 1, 0, 1, 36, 1,  3, 2, 1},
                {340,  1, 2017, 1, 0, 1, 36, 1,  3, 30, 1},  // 30
                {340,  3, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
                {1009,  1, 2017, 1, 0, 1, 36, 1,  3, 26, 1}, // 26
                {210,  1, 2017, 1, 0, 1, 36, 1,  3, 25, 1}, // 27
                {210,  2, 2017, 1, 0, 1, 36, 1,  3, 2, 1},
                {1,  1, 2017, 1, 0, 1, 36, 1,  3, 24, 1}, // 24
                {4377,  1, 2017, 1, 0, 1, 36, 1,  3, 15, 1}, // 30
                {4377,  3, 2017, 1, 0, 1, 36, 1,  3, 15, 1},
                {2354,  1, 2017, 1, 0, 1, 36, 1,  3, 20, 1}, // 20
                {800,  2, 2017, 1, 0, 1, 36, 1,  3, 0, 1}, // 0
                {200,  2, 2017, 1, 0, 1, 36, 1,  3, 0, 1}, // 0
                {960,  3, 2017, 1, 1, 2, 51, 1,  4, 0,  1}, // 0
                {960,  2, 2017, 1, 1, 2, 51, 1,  4, 0,  1},
                {960,  1, 2017, 1, 1, 2, 51, 1,  4, 0,  1}};
    vector <hogar> propuesto = muestraHomogenea(th,ti);
    bool esperado = res1 == propuesto || res2 == propuesto;
    EXPECT_EQ(true,esperado);
}

TEST(muestraHomogeneaTEST, sinSueldoReportados) {
    vector <hogar> res = {};

    eph_h th = {
            {960,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
            {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {210,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
    };

    eph_i ti = {{340,  1, 2017, 1, 0, 1, 36, 1,  3, -1, 1},
                {340,  3, 2017, 1, 0, 1, 36, 1,  3, -1, 1},
                {1009,  1, 2017, 1, 0, 1, 36, 1,  3, -1, 1},
                {210,  1, 2017, 1, 0, 1, 36, 1,  3, -1, 1},
                {210,  2, 2017, 1, 0, 1, 36, 1,  3, -1, 1},
                {4377,  1, 2017, 1, 0, 1, 36, 1,  3, -1, 1},
                {4377,  3, 2017, 1, 0, 1, 36, 1,  3, -1, 1},
                {960,  3, 2017, 1, 1, 2, 51, 1,  4, -1,  1},
                {960,  2, 2017, 1, 1, 2, 51, 1,  4, -1,  1},
                {960,  1, 2017, 1, 1, 2, 51, 1,  4, -1,  1}};
    assert(esEncuestaValida(th,ti));
    EXPECT_EQ(res,muestraHomogenea(th,ti));
}

//Nuevos test
TEST(muestraHomogeneaTEST, todosConSueldoCero) {
vector <hogar> res = {};

eph_h th = {
        {960,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
        {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
        {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
        {210,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
        {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
};

eph_i ti = {{340,  1, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
            {340,  3, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
            {1009,  1, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
            {210,  1, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
            {210,  2, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
            {4377,  1, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
            {4377,  3, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
            {960,  3, 2017, 1, 1, 2, 51, 1,  4, 0,  1},
            {960,  2, 2017, 1, 1, 2, 51, 1,  4, 0,  1},
            {960,  1, 2017, 1, 1, 2, 51, 1,  4, 0,  1}};
assert(esEncuestaValida(th,ti));
EXPECT_EQ(res,muestraHomogenea(th,ti));
}

//Nuevo test
TEST(muestraHomogeneaTEST, todoTHEsMuestraHomogenea) {
vector <hogar> res = {{960,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
                      {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
                      {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
                      {210,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
                      {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
};

eph_h th = {
        {960,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
        {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2},
        {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
        {210,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
        {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
};

eph_i ti = {{340,  1, 2017, 1, 0, 1, 36, 1,  3, 3, 1},
            {340,  3, 2017, 1, 0, 1, 36, 1,  3, 3, 1},
            {1009,  1, 2017, 1, 0, 1, 36, 1,  3, 9, 1},
            {210,  1, 2017, 1, 0, 1, 36, 1,  3, 6, 1},
            {210,  2, 2017, 1, 0, 1, 36, 1,  3, 6, 1},
            {4377,  1, 2017, 1, 0, 1, 36, 1,  3, 7, 1},
            {4377,  3, 2017, 1, 0, 1, 36, 1,  3, 8, 1},
            {960,  3, 2017, 1, 1, 2, 51, 1,  4, 1,  1},
            {960,  2, 2017, 1, 1, 2, 51, 1,  4, 1,  1},
            {960,  1, 2017, 1, 1, 2, 51, 1,  4, 1,  1}};
assert(esEncuestaValida(th,ti));
EXPECT_EQ(res,muestraHomogenea(th,ti));
}

//Nuevo test FALLA 
TEST(muestraHomogeneaTEST, testDosSecuenciasConMismaDif) {
    vector <hogar> res = {{210,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {2354,  2017, 1, 1, 2, 0, 1, 3, 1, 2},
            {800,  2017, 1, 1, 2, 0, 1, 3, 1, 2}};
            
    eph_h th = {
            {960,  2017, 1, 1, 1, 0, 1, 4, 1, 2}, //1
            {340,  2017, 1, 1, 1, 0, 1, 4, 1, 2}, //3
            {1009,  2017, 1, 1, 2, 0, 1, 3, 1, 2}, //5
            {210,  2017, 1, 1, 2, 0, 1, 3, 1, 2}, //8
            {4377,  2017, 1, 1, 2, 0, 1, 3, 1, 2}, //10
            {2354,  2017, 1, 1, 2, 0, 1, 3, 1, 2}, //12
            {800,  2017, 1, 1, 2, 0, 1, 3, 1, 2}}; //14

    eph_i ti = {{340,  1, 2017, 1, 0, 1, 36, 1,  3, 3, 1},
                {340,  3, 2017, 1, 0, 1, 36, 1,  3, 0, 1},
                {1009,  1, 2017, 1, 0, 1, 36, 1,  3, 5, 1},
                {210,  1, 2017, 1, 0, 1, 36, 1,  3, 4, 1}, //8
                {210,  2, 2017, 1, 0, 1, 36, 1,  3, 4, 1},
                {4377,  1, 2017, 1, 0, 1, 36, 1,  3, 5, 1}, //10
                {4377,  3, 2017, 1, 0, 1, 36, 1,  3, 5, 1},
                {960,  3, 2017, 1, 1, 2, 51, 1,  4, 1,  1},
                {960,  2, 2017, 1, 1, 2, 51, 1,  4, 0,  1},
                {960,  1, 2017, 1, 1, 2, 51, 1,  4, 0,  1},
                {2354,  1, 2017, 1, 0, 1, 36, 1,  3, 12, 1}, // 12
                {800,  2, 2017, 1, 0, 1, 36, 1,  3, 14, 1} // 14
                };
    assert(esEncuestaValida(th,ti));
    EXPECT_EQ(res,muestraHomogenea(th,ti));
}